<?php
/*
Plugin Name: Change Admin Username
Plugin URI: http://w-shadow.com/blog/2008/07/24/change-admin-username-in-wordpress/
Description: Lets you <a href='users.php?page=change_username'>change your username</a> to something other than "admin". 
Version: 1.0
Author: Janis Elsts
Author URI: http://w-shadow.com/blog/
*/

/*
Created by Janis Elsts (email : whiteshadow@w-shadow.com) 
It's GPL.
*/

if (!class_exists('ws_change_username')) {
	
class ws_change_username {
	function ws_change_username(){
		add_action('admin_menu', array(&$this, 'add_admin_menus'));
	}
	
	function add_admin_menus(){
		//only admin-level users with the edit_users capability can change their username
		add_submenu_page('users.php', 'Change Username', 'Change Username', 'edit_users', 
				'change_username', array(&$this, 'username_page'));
	}
	
	function username_page(){
		global $wpdb, $userdata;
		get_currentuserinfo();
		
		if (!empty($_POST['action']) && ($_POST['action']=='update') && !empty($_POST['new_username']) ){
			$new_username = $wpdb->escape($_POST['new_username']);
			$q = "UPDATE $wpdb->users SET user_login='$new_username' WHERE ID=$userdata->ID";
			if (false !== $wpdb->query($q)){
				$login_url = get_option('siteurl').'/wp-login.php';
				echo "<div id='message' class='updated fade'><p>
					<strong>Your username was changed to '$new_username'. 
					<a href='$login_url'>Log in</a> with this username now.</strong></p></div>";
			} else {
				echo "<div id='message' class='error'><p>
					<strong>A database error occured : $wpdb->last_error</strong></p></div>";
			}
		} 
?>
<div class="wrap">
<h2>Change Your Username</h2>
<form name="change_admin_username" method="post" 
action="<?php echo $_SERVER['PHP_SELF']; ?>?page=change_username">

<input type='hidden' name='action' value='update' />

<table class="form-table">
	<tr>
		<th><label for="current_username">Current Username</label></th>
		<td><input name="current_username" id="current_username" 
			type="text" value="<?php echo $userdata->user_login; ?>" size="30" 
			disabled="disabled" />
		</td>
	</tr>
	<tr>
		<th><label for="new_username">New Username</label></th>
		<td><input name="new_username" id="new_username" type="text"   
		 		value="<?php ?>" size="30" /></td>
	</tr>
</table>
<p>After clicking "Save Changes" you will need to log out and log in anew with your new username.</p>
<p class="submit"><input type="submit" name="submit" class="button" value="Save Changes" /></p>
  </form>

</div>
<?php
	}
}

}

$ws_cau = new ws_change_username;
?>